bash 4.4 fix
[distro-setup] / conflink
index e263e0687d7aebd0bcf3663c760ca4bd2a92f8d7..c385ca04e8e7c9738edaa7be5b480bb25ddef05d 100755 (executable)
--- a/conflink
+++ b/conflink
@@ -5,13 +5,16 @@ trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?"' ERR
 
 
 sysv() {
-    e "$@"
+    echo "$@"
     "$@"
 }
 
 
+#
+
+
 shopt -s nullglob
-shopt -s extglob
+shopt -s extglob # note, already set with bash -l
 
 # if we make a link back to the root, traversing the subdirs stops.
 # This makes it so we can do subdir directories. Must call with absolute
@@ -21,9 +24,9 @@ subdir-link-r() {
     local root="$1"
     local targets=()
     if [[ $2 ]]; then
-        targets=( "$2"/!(.git) )
+        targets=( "$2"/!(.git|..|.) )
     else
-        for f in "$1"/!(.git); do
+        for f in "$1"/!(.git|..|.); do
             [[ -d $f ]] && targets+=("$f") ||:
         done
     fi
@@ -32,14 +35,7 @@ subdir-link-r() {
         local fullpath="$(readlink -f "$path")"
         #e $fullpath $below # debug
         if [[ -f $path || $(dirname $(readlink -f "$fullpath")) == "$below" ]]; then
-            if [[ $dir == /p/* ]]; then
-                homes=(/home/ian)
-            else
-                homes=(/home/*)
-            fi
-            for user in ${homes[@]}; do
-                sysv lnf -T "$path" "$user/${path#$root/}"
-            done
+            sysv lnf -T "$path" "$HOME/${path#$root/}"
         elif [[ -d "$path" ]]; then
             subdir-link-r "$root" "$path"
         fi
@@ -47,19 +43,34 @@ subdir-link-r() {
 }
 
 common-file-setup() {
-    if [[ -e $1/subdir_files ]]; then
-        subdir-link-r $1/subdir_files
-    fi
-    local x=( $1/!(subdir_files|filesystem) )
-    (( ${#x[@]} >= 1 )) || return 0
-    sysv lnf ${x[@]} ~
-    # as of this writing, it doesn't exist in /a/c, but I've used it in the past.
-    if [[ -e $1/filesystem ]]; then
-        sysv s cp -R $1/filesystem/* /
-    fi
+    local dir fs_files x
+    for dir in "$@"; do
+        fs_files=( $dir/filesystem/* )
+        if [[ -e ${fs_files[0]} && $USER == ian ]]; then
+            # note, symlinks get resolved, not copied.
+            sysv s cp -RL ${fs_files[@]} /
+        fi
+        if [[ -e $dir/subdir_files ]]; then
+            subdir-link-r $dir/subdir_files
+        fi
+        local x=( $dir/!(subdir_files|filesystem|machine_specific) )
+        (( ${#x[@]} >= 1 )) || continue
+        sysv lnf ${x[@]} ~
+    done
 }
 
-# p needs to go first so .ssh link is created, then config link inside it
-for dir in {/a/c,/p/c}{,/machine_specific/$HOSTNAME}; do
-    common-file-setup $dir
-done
+all_dirs=({/a/c,/p/c}{,/machine_specific/$HOSTNAME})
+c_dirs=(/a/c{,/machine_specific/$HOSTNAME})
+case $USER in
+    ian)
+        # p needs to go first so .ssh link is created, then config link inside it
+        common-file-setup ${all_dirs[@]}
+        sudo -u traci "$BASH_SOURCE"
+        ;;
+    traci)
+        common-file-setup ${c_dirs[@]}
+        ;;
+    *)
+        echo "$0: error: unexpected user"; exit 1
+        ;;
+esac